#encoding: UTF-8

from PIL import ImageDraw, ImageFont, Image
from random import random
from datetime import datetime, timedelta, date
from time import gmtime, strftime
from sys import maxint

# German translation + Enhancements by Foobian

class traxx_renderer(abstractscreenrenderer):
	def __init__(self, lookup_path):
		# color definitions
		self.czarny = (0,0,0)
		self.czarny_gsmr = (25,25,25)
		self.czarny2_gsmr = (10,10,10)
		self.szary_gsmr = (200,200,200)
		self.czarny_diag = (0,0,0)
		self.bialy =(255,255,255)
		self.bialy_diag =(255,255,255)
		self.jszary =(218,218,218)
		self.niebieski =(0,100,255)
		self.niebieski_diag =(0,100,255)
		self.ed = (175,125,0)
		self.jasnoniebieski_diag = (133,128,255)
		self.zolty_diag = (255,215,0)
		self.czerwony_diag = (255,0,0)
		self.sredni_arial = ImageFont.truetype(lookup_path + 'fonts/arialbd.ttf', 34)
		self.maly_arial = ImageFont.truetype(lookup_path + 'fonts/arialbd.ttf', 26)
		self.bmaly_arial = ImageFont.truetype(lookup_path + 'fonts/arialbd.ttf', 16)
		self.gsmr1 = ImageFont.truetype(lookup_path + 'fonts/myriadpro-regular.otf', 22)
		self.gsmr2 = ImageFont.truetype(lookup_path + 'fonts/myriadpro-regular.otf', 14)
		self.gsmr3 = ImageFont.truetype(lookup_path + 'fonts/myriadpro-regular.otf', 18)
		self.gsmr4 = ImageFont.truetype(lookup_path + 'fonts/myriadpro-regular.otf', 80)

		lookup_path = lookup_path + "screen_traxx/"
		self.podklad = self.openimage(lookup_path + "ek1")
		self.ertms = Image.open(lookup_path + "ertms.png")
		self.diag_1_day = Image.open(lookup_path + "diag_1_day.png")
		self.diag_2_day = Image.open(lookup_path + "diag_2_day.png")
		self.diag_3_day = Image.open(lookup_path + "diag_3_day.png")
		self.diag_4_day = Image.open(lookup_path + "diag_4_day.png")
		self.diag_1_night = Image.open(lookup_path + "diag_1_night.png")
		self.diag_2_night = Image.open(lookup_path + "diag_2_night.png")
		self.diag_3_night = Image.open(lookup_path + "diag_3_night.png")
		self.diag_4_night = Image.open(lookup_path + "diag_4_night.png")
		self.obluga_day = Image.open(lookup_path + "obluga_day.png")
		self.obluga_night = Image.open(lookup_path + "obluga_night.png")
		self.maska  = Image.open(lookup_path + "maska.png")
		self.shp  = Image.open(lookup_path + "shp.png")
		self.pedal  = Image.open(lookup_path + "pedal.png")
		self.ws  = Image.open(lookup_path + "ws.png")
		self.szyna_zbiorcza  = Image.open(lookup_path + "szyna_zbiorcza.png")
		self.drzwi  = Image.open(lookup_path + "drzwi.png")
		self.fspbr = Image.open(lookup_path + "fspbr.png")
		self.serice_menu_selection  = Image.open(lookup_path + "serice_menu_selection.png")
		
		self.kilometry = (random()*300000)+5000
		self.last_time_update = 0
		self.dzis = datetime.now().timetuple().tm_yday
		self.rok = datetime.now().year
		self.last_hour = 10
		self.temp = (random()*15) + 20
		
	def _render(self, state):
#liczenie pojazdów
		pojazdy = 1
		if (state['unit_no'] == 1):
			pojazdy = 1
		if (state['unit_no'] == 2):
			pojazdy = 2
		if (state['unit_no'] == 3):
			pojazdy = 3
		if (state['unit_no'] == 4):
			pojazdy = 4
		if (state['unit_no'] > 4):
			pojazdy = 4
			
#light/dark mode switch
		nightmode = 0
		if state['universal3']:
			nightmode = 1
		if (nightmode==1):
			self.czarny_diag = (255,255,255)
			# self.bialy_diag =(255,255,255)
			# self.niebieski_diag =(0,0,132)
			# self.jasnoniebieski_diag = (133,128,255)
			# self.zolty_diag = (255,254,2)
			self.czarny_gsmr = (200,200,200)
			self.szary_gsmr = (25,25,25)
			
		else:
			self.czarny_diag = (0,0,0)
			self.niebieski_diag =(0,0,255)
			self.czarny_gsmr = (25,25,25)
			self.szary_gsmr = (200,200,200)
			
#screenmode
		screenmode = state['screenmode'] #mainscreen/servicescreen
		# kopia obrazka na potrzeby tego jednego renderowania
		obrazek = self.podklad.copy()
		# chcemy rysowac po teksturze pulpitu
		draw = ImageDraw.Draw(obrazek)
		
#velocity
		speed = float(state['velocity'])
		if speed > 180:
			speed = 180
#time
		if state['seconds'] != self.last_time_update:
			dt = state['seconds'] - self.last_time_update
			if dt < 0:
				dt+=60
			self.kilometry += dt*speed * 0.0002778
			self.last_time_update = state['seconds']
		if state['hours']<10:
			godz = "0" + str(state['hours'])
		else:
			godz = str(state['hours'])
		if state['minutes']<10:
			min = "0" + str(state['minutes'])
		else:
			min = str(state['minutes'])
		if state['seconds']<10:
			sec = "0" +str(state['seconds'])
		else:
			sec = str(state['seconds'])
		
		
#date
		if self.last_hour == 23 and state['hours'] == 0:
			self.dzis = self.dzis+1 # has just struck midnight
		self.last_hour = state['hours']
		data = datetime(self.rok, 1, 1) + timedelta(self.dzis - 1)
		dzien = datetime.weekday(data)
		data = data.strftime("%d.%m.%Y")
		DayL = ['Mo','Di','Mi','Do','Fr','Sa','So']
		zmienna_kanalu = str(state['radio_channel'])
		
#ERTMS------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		if state['eimp_c1_batt']==1:
			obrazek.paste(self.ertms,(134,1038),self.ertms)
	#ERTMS godzina
			draw.text((576,1045), godz +":"+ min +":"+ sec, fill=self.jszary, font=self.sredni_arial)
			
	#ERTMS prędkościomierz
			draw.ellipse([(431, 1249), (521, 1339)], fill=self.bialy)
			rotate = speed * 270 / 180 + 45
			rad =  radians(rotate)
			srodek_tacho = (476, 1294)
			point = (-10,37)
			p1 = (point[0]*cos(rad)-point[1]*sin(rad) + srodek_tacho[0],point[0]*sin(rad)+point[1]*cos(rad) + srodek_tacho[1])
			point = (-10,137)
			p2 = (point[0]*cos(rad)-point[1]*sin(rad) + srodek_tacho[0],point[0]*sin(rad)+point[1]*cos(rad) + srodek_tacho[1])
			point = (-4,145)
			p3 = (point[0]*cos(rad)-point[1]*sin(rad) + srodek_tacho[0],point[0]*sin(rad)+point[1]*cos(rad) + srodek_tacho[1])
			point = (-4,187)
			p4 = (point[0]*cos(rad)-point[1]*sin(rad) + srodek_tacho[0],point[0]*sin(rad)+point[1]*cos(rad) + srodek_tacho[1])
			point = (10,37)
			p8 = (point[0]*cos(rad)-point[1]*sin(rad) + srodek_tacho[0],point[0]*sin(rad)+point[1]*cos(rad) + srodek_tacho[1])
			point = (10,137)
			p7 = (point[0]*cos(rad)-point[1]*sin(rad) + srodek_tacho[0],point[0]*sin(rad)+point[1]*cos(rad) + srodek_tacho[1])
			point = (4,145)
			p6 = (point[0]*cos(rad)-point[1]*sin(rad) + srodek_tacho[0],point[0]*sin(rad)+point[1]*cos(rad) + srodek_tacho[1])
			point = (4,187)
			p5 = (point[0]*cos(rad)-point[1]*sin(rad) + srodek_tacho[0],point[0]*sin(rad)+point[1]*cos(rad) + srodek_tacho[1])
			draw.polygon([p1,p2,p3,p4,p5,p6,p7,p8],fill=self.bialy)
			
			self.print_center(draw, '%d' % speed, 476, 1294, self.sredni_arial, self.czarny)

	#ERTMS tempomat
			tempomat = state['new_speed']
			if tempomat > 0:
				rotate = tempomat * 270 / 180 - 135
				rad =  radians(rotate)
				srodek = (476, 1294)
				point = (0,-193)
				p1 = (srodek[0]+point[0]*cos(rad)-point[1]*sin(rad),srodek[1]+point[1]*cos(rad)+point[0]*sin(rad))
				point = (-12,-205)
				p2 = (srodek[0]+point[0]*cos(rad)-point[1]*sin(rad),srodek[1]+point[1]*cos(rad)+point[0]*sin(rad))
				point = (0,-217)
				p3 = (srodek[0]+point[0]*cos(rad)-point[1]*sin(rad),srodek[1]+point[1]*cos(rad)+point[0]*sin(rad))
				point = (12,-205)
				p4 = (srodek[0]+point[0]*cos(rad)-point[1]*sin(rad),srodek[1]+point[1]*cos(rad)+point[0]*sin(rad))
				draw.polygon([p1,p2,p3,p4],fill=self.zolty_diag)
			
			
	#ERTMS tractive / braking force
			
			#siła pociągowa
			frt = (state['eimp_c1_frt'])
			if not -maxint-1 <= frt <= maxint:
				frt = (frt + (maxint + 1)) % (2 * (maxint + 1)) - maxint - 1
			end = int(frt / 2 - 90)
			draw.pieslice((771,1071,1220, 1520), -90, end, fill=self.niebieski)
			#siła hamowania
			frb = (state['eimp_c1_frb'])
			if not -maxint-1 <= frb <= maxint:
				frb = (frb + (maxint + 1)) % (2 * (maxint + 1)) - maxint - 1
			end = int(-frb - 90)
			draw.pieslice((771,1071,1220, 1520), end, -90 , fill=self.ed)
			
			obrazek.paste(self.maska,(730,1041),self.maska)
			
			#siła zadana
			# fd = state['eimp_t_fd']
			# if (fd<0):
				# fd=fd*2
			# rotate = fd * 70 / 140
			# if (rotate>140 and fd>0):
				# rotate=140
			# if (rotate<-140 and fd<0):
				# rotate=-140
			pd = state['eimp_t_pd']
			if (abs(speed)<0.01):
				pd = 0
			rotate = pd * 150
			if (rotate>140 and pd>0):
				rotate=140
			if (rotate<-140 and pd<0):
				rotate=-140
			rad =  radians(rotate)
			srodek = (995, 1295)
			point = (0,-220)
			p1 = (srodek[0]+point[0]*cos(rad)-point[1]*sin(rad),srodek[1]+point[1]*cos(rad)+point[0]*sin(rad))
			point = (-13,-249)
			p2 = (srodek[0]+point[0]*cos(rad)-point[1]*sin(rad),srodek[1]+point[1]*cos(rad)+point[0]*sin(rad))
			point = (13,-249)
			p3 = (srodek[0]+point[0]*cos(rad)-point[1]*sin(rad),srodek[1]+point[1]*cos(rad)+point[0]*sin(rad))
			draw.polygon([p1,p2,p3],fill=self.bialy)
	#ERTMS Ikonki
			if (state['shp']):
				obrazek.paste(self.shp,(303,1551),self.shp)
			if (state['ca']):
				obrazek.paste(self.pedal,(1155,1551),self.pedal)
			if (state['eimp_c1_ms']==0):
				obrazek.paste(self.szyna_zbiorcza,(729,1551),self.szyna_zbiorcza)
			if (state['eimp_c1_heat']==0):
				obrazek.paste(self.ws,(801,1551),self.ws)
			if (state['doors_2']==0 and state['doors_no_2']>0):
				obrazek.paste(self.drzwi,(942,1551),self.drzwi)
			
#MTD--------------------------------------------------------------------------------------------------------------------------------------------------------------------				
			if (screenmode == "mainscreen"):
				if (pojazdy ==1):
					if (nightmode==0):
						obrazek.paste(self.diag_1_day,(130,54),self.diag_1_day)
					if (nightmode==1):
						obrazek.paste(self.diag_1_night,(130,54),self.diag_1_night)
				if (pojazdy ==2):
					if (nightmode==0):
						obrazek.paste(self.diag_2_day,(130,54),self.diag_2_day)
					if (nightmode==1):
						obrazek.paste(self.diag_2_night,(130,54),self.diag_2_night)
				if (pojazdy ==3):
					if (nightmode==0):
						obrazek.paste(self.diag_3_day,(130,54),self.diag_3_day)
					if (nightmode==1):
						obrazek.paste(self.diag_3_night,(130,54),self.diag_3_night)
				if (pojazdy ==4):
					if (nightmode==0):
						obrazek.paste(self.diag_4_day,(130,54),self.diag_4_day)
					if (nightmode==1):
						obrazek.paste(self.diag_4_night,(130,54),self.diag_4_night)
		#diag date
				draw.text((1021,60), DayL[dzien] + ", " + data, fill=self.czarny_diag, font=self.sredni_arial)
		#diag train number
				trainnumber = state['trainnumber']
				if ((state['trainnumber'] == 'none') or (state['trainnumber'] == 'rozklad') ):
					trainnumber = ' '
				draw.text((1062,385), 'Zug  ' + trainnumber, fill=self.czarny_diag, font=self.maly_arial)
		#diag długość składu
				distance_counter = state['distance_counter']
				
				if (distance_counter > 0):
					draw.text((1026,473), str('%d' % (state['train_length'] - distance_counter)) + ' m', fill=self.zolty_diag, font=self.sredni_arial)
		#diag clock
				#obroty wskazówek w radianach
				sekundy = radians((state['seconds']*6))
				minuty = radians((state['minutes']*6))
				godziny = radians((state['hours']*30 + state['minutes']*0.5)) #składowa minutowa dla płynnego ruchu
				srodek = (1130, 242)
				#długości wskazówek
				r_s = 105
				r_m = 98
				r_g = 82
				#punkty końcowe
				k_s = (srodek[0]+(r_s*sin(sekundy)), srodek[1]-(r_s*cos(sekundy)))
				k_m = (srodek[0]+(r_m*sin(minuty)), srodek[1]-(r_m*cos(minuty)))
				k_g = (srodek[0]+(r_g*sin(godziny)), srodek[1]-(r_g*cos(godziny)))
				p_s = (srodek[0]+(7*(-sin(sekundy))), srodek[1]-(7*(-cos(sekundy))))
				p_m = (srodek[0]+(7*(-sin(minuty))), srodek[1]-(7*(-cos(minuty))))
				p_g = (srodek[0]+(7*(-sin(godziny))), srodek[1]-(7*(-cos(godziny))))
				#rysowanie wskazówek
				draw.line((p_s[0], p_s[1],k_s[0], k_s[1]),fill=self.czarny_diag, width=2)
				draw.line((p_m[0], p_m[1],k_m[0], k_m[1]),fill=self.czarny_diag, width=4)
				draw.line((p_g[0], p_g[1],k_g[0], k_g[1]),fill=self.czarny_diag, width=8)
				
		#diag meters 1
				if (pojazdy ==1):
					#wolto
					wolt = state['eimp_c1_uhv']
					if wolt>5000:
						wolt=5000
					napiecie = 586-(0.0866*wolt)
					draw.rectangle(((266,586),(358,napiecie)), fill=self.niebieski_diag)
					if wolt>2500:
						draw.rectangle(((267,608),(358,646)), fill=self.niebieski_diag)
					if state['eimp_c1_ms']:
						draw.text((271,613), u'HS Ein', font=self.maly_arial, fill=self.bialy_diag)
					elif wolt>2500:
						draw.text((265,613), u'HS Aus', font=self.maly_arial, fill=self.bialy_diag)
					else:
						draw.text((265,613), u'HS Aus', font=self.maly_arial, fill=self.czarny_diag)
						
					#ampery
					prad = state['eimp_c1_ihv']
					if prad<0:
						prad=0
					self.print_fixed_with(draw, '2000', (535,607), 4, self.sredni_arial, self.czarny_diag)
					if prad>3700:
						prad=3700
					ampery = 586-(0.1183*prad)
					draw.rectangle(((532,586),(625,ampery)), fill=self.niebieski_diag)
					
					
					#hbl
					hbl = state['eimp_pn1_sp']
					cisn = 586-(34.6666*hbl) 
					draw.rectangle(((727,647),(820,cisn)), fill=self.niebieski_diag)
		#diag meters 2
				if (pojazdy == 2):
					#wolto1
					wolt = state['eimp_c1_uhv']
					if wolt>5000:
						wolt=5000
					napiecie = 586-(0.0866*wolt)
					draw.rectangle(((266,586),(358,napiecie)), fill=self.niebieski_diag)
					if wolt>2500:
						draw.rectangle(((267,608),(358,646)), fill=self.niebieski_diag)
					if state['eimp_c1_ms']:
						draw.text((271,613), u'HS Ein', font=self.maly_arial, fill=self.bialy_diag)
					elif wolt>2500:
						draw.text((265,613), u'HS Aus', font=self.maly_arial, fill=self.bialy_diag)
					else:
						draw.text((265,613), u'HS Aus', font=self.maly_arial, fill=self.czarny_diag)
					#wolto2
					wolt = state['eimp_c2_uhv']
					if wolt>5000:
						wolt=5000
					napiecie = 586-(0.0866*wolt)
					draw.rectangle(((449,586),(541,napiecie)), fill=self.niebieski_diag)
					if wolt>2500:
						draw.rectangle(((450,608),(541,646)), fill=self.niebieski_diag)
					if state['eimp_c2_ms']:
						draw.text((454,613), u'HS Ein', font=self.maly_arial, fill=self.bialy_diag)
					elif wolt>2500:
						draw.text((448,613), u'HS Aus', font=self.maly_arial, fill=self.bialy_diag)
					else:
						draw.text((448,613), u'HS Aus', font=self.maly_arial, fill=self.czarny_diag)
						
					#ampery
					prad = state['eimp_t_itothv']
					if prad<0:
						prad=0
					self.print_fixed_with(draw, '2000', (728,607), 4, self.sredni_arial, self.czarny_diag)
					if prad>3700:
						prad=3700
					ampery = 586-(0.1183*prad)
					draw.rectangle(((725,586),(818,ampery)), fill=self.niebieski_diag)
					
		#diag meters 3
				if (pojazdy == 3):
					#wolto1
					wolt = state['eimp_c1_uhv']
					if wolt>5000:
						wolt=5000
					napiecie = 586-(0.0866*wolt)
					draw.rectangle(((267,586),(358,napiecie)), fill=self.niebieski_diag)
					if wolt>2500:
						draw.rectangle(((267,608),(358,646)), fill=self.niebieski_diag)
					if state['eimp_c1_ms']:
						draw.text((271,613), u'HS Ein', font=self.maly_arial, fill=self.bialy_diag)
					elif wolt>2500:
						draw.text((265,613), u'HS Aus', font=self.maly_arial, fill=self.bialy_diag)
					else:
						draw.text((265,613), u'HS Aus', font=self.maly_arial, fill=self.czarny_diag)
					#wolto2
					wolt = state['eimp_c2_uhv']
					if wolt>5000:
						wolt=5000
					napiecie = 586-(0.0866*wolt)
					draw.rectangle(((448,586),(541,napiecie)), fill=self.niebieski_diag)
					if wolt>2500:
						draw.rectangle(((448,608),(541,646)), fill=self.niebieski_diag)
					if state['eimp_c2_ms']:
						draw.text((452,613), u'HS Ein', font=self.maly_arial, fill=self.bialy_diag)
					elif wolt>2500:
						draw.text((446,613), u'HS Aus', font=self.maly_arial, fill=self.bialy_diag)
					else:
						draw.text((446,613), u'HS Aus', font=self.maly_arial, fill=self.czarny_diag)
					#wolto3
					wolt = state['eimp_c3_uhv']
					if wolt>5000:
						wolt=5000
					napiecie = 586-(0.0866*wolt)
					draw.rectangle(((630,586),(722,napiecie)), fill=self.niebieski_diag)
					if wolt>2500:
						draw.rectangle(((630,608),(722,646)), fill=self.niebieski_diag)
					if state['eimp_c3_ms']:
						draw.text((634,613), u'HS Ein', font=self.maly_arial, fill=self.bialy_diag)
					elif wolt>2500:
						draw.text((628,613), u'HS Aus', font=self.maly_arial, fill=self.bialy_diag)
					else:
						draw.text((628,613), u'HS Aus', font=self.maly_arial, fill=self.czarny_diag)
					#ampery
					prad = state['eimp_t_itothv']
					if prad<0:
						prad=0
					self.print_fixed_with(draw, '2000', (836,607), 4, self.sredni_arial, self.czarny_diag)
					if prad>3700:
						prad=3700
					ampery = 586-(0.1183*prad)
					draw.rectangle(((833,586),(925,ampery)), fill=self.niebieski_diag)

		#diag meters 4
				if (pojazdy == 4):
					#wolto1
					wolt = state['eimp_c1_uhv']
					if wolt>5000:
						wolt=5000
					napiecie = 586-(0.0866*wolt)
					draw.rectangle(((229,586),(302,napiecie)), fill=self.niebieski_diag)
					if wolt>2500:
						draw.rectangle(((229,608),(302,646)), fill=self.niebieski_diag)
					if state['eimp_c1_ms']:
						draw.text((241,618), u'HS Ein', font=self.bmaly_arial, fill=self.bialy_diag)
					elif wolt>2500:
						draw.text((235,618), u'HS Aus', font=self.bmaly_arial, fill=self.bialy_diag)
					else:
						draw.text((235,618), u'HS Aus', font=self.bmaly_arial, fill=self.czarny_diag)
					#wolto2
					wolt = state['eimp_c2_uhv']
					if wolt>5000:
						wolt=5000
					napiecie = 586-(0.0866*wolt)
					draw.rectangle(((392,586),(465,napiecie)), fill=self.niebieski_diag)
					if wolt>2500:
						draw.rectangle(((392,608),(465,646)), fill=self.niebieski_diag)
					if state['eimp_c2_ms']:
						draw.text((404,618), u'HS Ein', font=self.bmaly_arial, fill=self.bialy_diag)
					elif wolt>2500:
						draw.text((398,618), u'HS Aus', font=self.bmaly_arial, fill=self.bialy_diag)
					else:
						draw.text((398,618), u'HS Aus', font=self.bmaly_arial, fill=self.czarny_diag)
					#wolto3
					wolt = state['eimp_c3_uhv']
					if wolt>5000:
						wolt=5000
					napiecie = 586-(0.0866*wolt)
					draw.rectangle(((555,586),(628,napiecie)), fill=self.niebieski_diag)
					if wolt>2500:
						draw.rectangle(((555,608),(628,646)), fill=self.niebieski_diag)
					if state['eimp_c3_ms']:
						draw.text((567,618), u'HS Ein', font=self.bmaly_arial, fill=self.bialy_diag)
					elif wolt>2500:
						draw.text((561,618), u'HS Aus', font=self.bmaly_arial, fill=self.bialy_diag)
					else:
						draw.text((561,618), u'HS Aus', font=self.bmaly_arial, fill=self.czarny_diag)
					#wolto4
					wolt = state['eimp_c4_uhv']
					if wolt>5000:
						wolt=5000
					napiecie = 586-(0.0866*wolt)
					draw.rectangle(((717,586),(790,napiecie)), fill=self.niebieski_diag)
					if wolt>2500:
						draw.rectangle(((717,608),(790,646)), fill=self.niebieski_diag)
					if state['eimp_c4_ms']:
						draw.text((729,618), u'HS Ein', font=self.bmaly_arial, fill=self.bialy_diag)
					elif wolt>2500:
						draw.text((723,618), u'HS Aus', font=self.bmaly_arial, fill=self.bialy_diag)
					else:
						draw.text((723,618), u'HS Aus', font=self.bmaly_arial, fill=self.czarny_diag)
					#ampery
					prad = state['eimp_t_itothv']
					if prad<0:
						prad=0
					self.print_fixed_with(draw, '2000', (886,607), 4, self.sredni_arial, self.czarny_diag)
					if prad>3700:
						prad=3700
					ampery = 586-(0.1183*prad)
					draw.rectangle(((882,586),(959,ampery)), fill=self.niebieski_diag)


			if (screenmode == "servicescreen"):
				if (nightmode==0):
					obrazek.paste(self.obluga_day,(130,54),self.obluga_day)
				if (nightmode==1):
					obrazek.paste(self.obluga_night,(130,54),self.obluga_night)
				draw.text((142,61), DayL[dzien] + ", " + data, fill=self.czarny_diag, font=self.maly_arial)
				draw.text((142,90), godz +":"+ min +":"+ sec, fill=self.czarny_diag, font=self.maly_arial)
				menuposition = state['menuposition']
				obrazek.paste(self.serice_menu_selection,(424,149+(menuposition*55)),self.serice_menu_selection)
				menupositionfontcolor = [self.czarny_diag for i in range(10)]
				menupositionfontcolor[menuposition] = self.bialy_diag
				draw.text((430,161), "Zuglicht", fill=menupositionfontcolor[0], font=self.maly_arial)
				draw.text((430,216), u"Nachlüften", fill=menupositionfontcolor[1], font=self.maly_arial)
				draw.text((430,271), "Stromabnehmer", fill=menupositionfontcolor[2], font=self.maly_arial)
				draw.text((430,326), "Luftpresser", fill=menupositionfontcolor[3], font=self.maly_arial)
				draw.text((430,381), "Bremsstellung", fill=menupositionfontcolor[4], font=self.maly_arial)
				draw.text((430,436), "AFB", fill=menupositionfontcolor[5], font=self.maly_arial)
				draw.text((430,491), "Betriebsart EP Bremse", fill=menupositionfontcolor[6], font=self.maly_arial)
				draw.text((430,546), "Hauptluftleitung", fill=menupositionfontcolor[7], font=self.maly_arial)
				draw.text((430,601), "DG 1", fill=menupositionfontcolor[8], font=self.maly_arial)
				draw.text((430,656), "DG 2", fill=menupositionfontcolor[9], font=self.maly_arial)
				service_swiatla = state['service_swiatla']
				service_uzupelnienie = state['service_uzupelnienie']
				service_pantografy = state['service_pantografy']
				service_sprezarka = state['service_sprezarka']
				service_nastawaham = state['service_nastawaham']
				service_asj = state['service_asj']
				service_trybep = state['service_trybep']
				service_trybpg = state['service_trybpg']
				service_ww1 = state['service_ww1']
				service_ww2 = state['service_ww2']

				#softkey descriptions
				self.print_center(draw, u'Prüfen', 1095, 849, self.maly_arial, self.czarny_diag)
				self.print_center(draw, 'WTB', 980, 849, self.maly_arial, self.czarny_diag)
				if (menuposition == 0): #światła pociągu
					if (service_swiatla != 0):
						self.print_center(draw, 'Aus', 185, 849, self.maly_arial, self.czarny_diag)
					if (service_swiatla != 1):
						self.print_center(draw, 'Ein', 300, 849, self.maly_arial, self.czarny_diag)
				if (menuposition == 1): #zwłoka wentylatorów (uzupełnienie)
					if (service_uzupelnienie == 0):
						self.print_center(draw, 'Ein', 185, 849, self.maly_arial, self.czarny_diag)
					if (service_uzupelnienie == 1):
						self.print_center(draw, 'Aus', 185, 849, self.maly_arial, self.czarny_diag)
				if (menuposition == 2): #pantograph
					if (service_pantografy != 0):
						self.print_center(draw, u'auto-\nmatisch', 185, 849, self.maly_arial, self.czarny_diag)
					if (service_pantografy != 1):
						self.print_center(draw, 'SA 1', 300, 849, self.maly_arial, self.czarny_diag)
					if (service_pantografy != 2):
						self.print_center(draw, 'SA 2', 413, 849, self.maly_arial, self.czarny_diag)
					if (service_pantografy != 3):
						self.print_center(draw, 'SA 1\nund\nSA 2', 527, 849, self.maly_arial, self.czarny_diag)
				if (menuposition == 3): #compressor
					if (service_sprezarka != 2):
						self.print_center(draw, u'auto-\nmatisch', 185, 849, self.maly_arial, self.czarny_diag)
					if (service_sprezarka != 0):
						self.print_center(draw, 'Aus', 300, 849, self.maly_arial, self.czarny_diag)
					if (service_sprezarka != 1):
						self.print_center(draw, 'Ein', 413, 849, self.maly_arial, self.czarny_diag)
				if (menuposition == 4): #nastawa hamulca
					if (service_nastawaham != 1):
						self.print_center(draw, 'P', 185, 849, self.maly_arial, self.czarny_diag)
					if (service_nastawaham != 0):
						self.print_center(draw, 'G', 300, 849, self.maly_arial, self.czarny_diag)
					if (service_nastawaham != 2):
						self.print_center(draw, 'R', 413, 849, self.maly_arial, self.czarny_diag)
				if (menuposition == 5): #asj
					if (service_asj != 0):
						self.print_center(draw, 'Aus', 185, 849, self.maly_arial, self.czarny_diag)
					if (service_asj != 1):
						self.print_center(draw, 'Ein', 300, 849, self.maly_arial, self.czarny_diag)
				if (menuposition == 6): #ep brake mode
					if (service_trybep == 0):
						self.print_center(draw, 'Ein', 185, 849, self.maly_arial, self.czarny_diag)
					if (service_trybep == 1):
						self.print_center(draw, 'Aus', 185, 849, self.maly_arial, self.czarny_diag)
					self.print_center(draw, u'UIC\nNBÜ ep', 413, 849, self.maly_arial, self.czarny_diag)
					self.print_center(draw, u'UIC\n ep', 527, 849, self.maly_arial, self.czarny_diag)
					self.print_center(draw, u'UIC ep\neinfach', 754, 849, self.maly_arial, self.czarny_diag)
				if (menuposition == 7): #sterowanie pg
					if (service_trybpg != 0):
						self.print_center(draw, u'BrB\n pn', 185, 849, self.maly_arial, self.czarny_diag)
					if (service_trybpg != 1):
						self.print_center(draw, u'BrB\n el', 300, 849, self.maly_arial, self.czarny_diag)
				if (menuposition == 8): #DG1
					if (service_ww1 != 0):
						self.print_center(draw, u'BrB\n pn', 185, 849, self.maly_arial, self.czarny_diag)
					if (service_ww1 != 1):
						self.print_center(draw, u'BrB\n el', 300, 849, self.maly_arial, self.czarny_diag)
				if (menuposition == 9): #DG2
					if (service_ww2 != 0):
						self.print_center(draw, u'BrB\n pn', 185, 849, self.maly_arial, self.czarny_diag)
					if (service_ww2 != 1):
						self.print_center(draw, u'BrB\n el', 300, 849, self.maly_arial, self.czarny_diag)

				if (service_swiatla == 0):
					self.print_center(draw, 'Aus', 797, 173, self.maly_arial, self.czarny_diag)
				elif (service_swiatla == 1):
					self.print_center(draw, 'Ein', 797, 173, self.maly_arial, self.czarny_diag)
				if (service_uzupelnienie == 0):
					self.print_center(draw, 'Aus', 797, 228, self.maly_arial, self.czarny_diag)
				elif (service_uzupelnienie == 1):
					self.print_center(draw, 'Auto', 797, 228, self.maly_arial, self.czarny_diag)
				if (service_pantografy == 0):
					self.print_center(draw, 'Auto', 797, 283, self.maly_arial, self.czarny_diag)
				elif (service_pantografy == 1):
					self.print_center(draw, 'SA 1', 797, 283, self.maly_arial, self.czarny_diag)
				elif (service_pantografy == 2):
					self.print_center(draw, 'SA 2', 797, 283, self.maly_arial, self.czarny_diag)
				elif (service_pantografy == 3):
					self.print_center(draw, u'SA1 & SA2', 797, 283, self.maly_arial, self.czarny_diag)
				if (service_sprezarka == 0):
					self.print_center(draw, 'Aus', 797, 338, self.maly_arial, self.czarny_diag)
				elif (service_sprezarka == 1):
					self.print_center(draw, 'Ein', 797, 338, self.maly_arial, self.czarny_diag)
				elif (service_sprezarka == 2):
					self.print_center(draw, 'Auto', 797, 338, self.maly_arial, self.czarny_diag)
				if (service_nastawaham == 1):
					self.print_center(draw, 'P', 797, 393, self.maly_arial, self.czarny_diag)
				elif (service_nastawaham == 0):
					self.print_center(draw, 'G', 797, 393, self.maly_arial, self.czarny_diag)
				elif (service_nastawaham == 2):
					self.print_center(draw, 'R', 797, 393, self.maly_arial, self.czarny_diag)
				if (service_asj == 0):
					self.print_center(draw, 'Aus', 797, 448, self.maly_arial, self.czarny_diag)
				elif (service_asj == 1):
					self.print_center(draw, 'Ein', 797, 448, self.maly_arial, self.czarny_diag)
				if (service_trybep == 0):
					self.print_center(draw, 'Aus', 797, 503, self.maly_arial, self.czarny_diag)
				elif (service_trybep == 1):
					self.print_center(draw, 'Ein', 797, 503, self.maly_arial, self.czarny_diag)
				if (service_trybpg == 0):
					self.print_center(draw, 'pneu', 797, 558, self.maly_arial, self.czarny_diag)
				elif (service_trybpg == 1):
					self.print_center(draw, 'el', 797, 558, self.maly_arial, self.czarny_diag)
				if (service_ww1 == 0):
					self.print_center(draw, 'pneu', 797, 613, self.maly_arial, self.czarny_diag)
				elif (service_ww1 == 1):
					self.print_center(draw, 'el', 797, 613, self.maly_arial, self.czarny_diag)
				if (service_ww2 == 0):
					self.print_center(draw, 'pneu', 797, 668, self.maly_arial, self.czarny_diag)
				elif (service_ww2 == 1):
					self.print_center(draw, 'el', 797, 668, self.maly_arial, self.czarny_diag)

		#diag status3
			#Hamulec bezpośredni nie jest luzowany
			#Blokada trakcji (wywaliło szybki)
			#Blokada trakcji przy zmianie pantografu
			#Trwa przegrupowanie przetwornicy pokładowej
			#Zmiana sterowania hamowaniem wyrównać przewód główny #po zmianie sterowania ep/pn
			if (state['service_asj'] == 1):
				draw.rectangle(((473,719),(550,787)), fill=self.niebieski_diag)
				self.print_center(draw, 'AFB', 511, 752, self.maly_arial, self.bialy)
			if ((state['brakes_1_spring_active'])):
				obrazek.paste(self.fspbr,(387,719),self.fspbr)
			if ((state['brakes_1_spring_active']) and (state['direction'] != 0)):
				draw.rectangle(((558,720),(969,784)), fill=self.jasnoniebieski_diag)
				self.print_center(draw, u'FspBr lösen', 763, 752, self.maly_arial, self.bialy)
			#Odblokować urządzenie czuwakowe #zmostkowany czuwak
			if (state['eimp_c1_ms'] & (state['direction'] == 0)):
				draw.rectangle(((558,720),(969,784)), fill=self.zolty_diag)
				self.print_center(draw, 'Traktionssperre', 763, 752, self.maly_arial, self.czerwony_diag)
			if (state['main_ready'] & (state['eimp_c1_ms'] == 0)):
				draw.rectangle(((558,720),(969,784)), fill=self.jasnoniebieski_diag)
				self.print_center(draw, u'Hauptschalter einschalten', 763, 752, self.maly_arial, self.bialy)
			#Blokada wyłącznika szybkiego
			#Przegrupowanie napędu
			if (state['eimp_c1_ms'] == 0 and state['main_ctrl_actual_pos'] !=3):
				draw.rectangle(((558,720),(969,784)), fill=self.jasnoniebieski_diag)
				self.print_center(draw, u'Fahrschalter in Stellung „0” um\nHauptschalter einzulegen', 763, 752, self.bmaly_arial, self.bialy)
			if (state['pantpress'] < 3.5):
				draw.rectangle(((558,720),(969,784)), fill=self.jasnoniebieski_diag)
				self.print_center(draw, u'Zbyt niskie ciśnienie powietrza wyłącznika głównego', 763, 752, self.bmaly_arial, self.bialy)
			if ((state['cab'] != 0) and ((state['eimp_u1_pf'] == 0) and (state['eimp_u1_pr'] == 0))): #kabina aktywna; pantograf opuszczony OK
				draw.rectangle(((558,720),(969,784)), fill=self.jasnoniebieski_diag)
				self.print_center(draw, 'SA heben', 763, 752, self.maly_arial, self.bialy)
			if (state['cab'] == 0):
				draw.rectangle(((558,720),(969,784)), fill=self.jasnoniebieski_diag)
				self.print_center(draw, u'Führertisch inaktiv', 763, 752, self.maly_arial, self.bialy)
			#Odblokować pantografy #odcięte pantografy

#GSMR------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		if state['radio_active']:
			#tlo
			draw.rectangle(((1287,15),(1756,304)), fill=self.czarny2_gsmr)
			draw.rectangle(((1290,25),(1751,298)), fill=self.szary_gsmr)
			#ikonka trojkat rog
			draw.polygon([1293,69,1325,69,1325,42],fill=self.czarny_gsmr)
			
			#volume level
			draw.polygon([1720,165,1745,165,1745,225],outline=self.czarny_gsmr)
			draw.line((1725,176, 1745, 176), fill=self.czarny_gsmr, width=2)
			draw.line((1730,187, 1745, 187), fill=self.czarny_gsmr, width=2)		
			draw.line((1735,198, 1745, 198), fill=self.czarny_gsmr, width=2)	
			draw.polygon([1730,187,1745,187,1745,225],fill=self.czarny_gsmr) # 1745 = right edge
			
			#contrast icon
			draw.ellipse([1294,98,1326,151],outline=self.czarny_gsmr)
			draw.pieslice([1294,98,1326,151],-90, 90, fill=self.czarny_gsmr)
			
			#brightness icon
			draw.ellipse([1298,170,1322,214],outline=self.czarny_gsmr)
			draw.line((1310,164, 1310, 170), fill=self.czarny_gsmr, width=1)
			draw.line((1324,167, 1320, 176), fill=self.czarny_gsmr, width=1)
			draw.line((1327,192, 1322, 192), fill=self.czarny_gsmr, width=1)
			draw.line((1324,215, 1319, 207), fill=self.czarny_gsmr, width=1)		
			draw.line((1310,220, 1310, 214), fill=self.czarny_gsmr, width=1)	
			draw.line((1297,215, 1302, 206), fill=self.czarny_gsmr, width=1)	
			draw.line((1293,192, 1298, 192), fill=self.czarny_gsmr, width=1)	
			draw.line((1296,168, 1302, 177), fill=self.czarny_gsmr, width=1)	
			

			#placek po srodku
			# draw.rectangle(((1482,76),(1571,197)), fill=self.czarny_gsmr)
			# draw.rectangle(((1488,69),(1563,75)), fill=self.czarny_gsmr)
			# draw.rectangle(((1488,190),(1563,204)), fill=self.czarny_gsmr)
			# draw.pieslice([1482,190,1499,204],90, 180, fill=self.czarny_gsmr)
			# draw.pieslice([1555,190,1571,204],0, 90, fill=self.czarny_gsmr)
			# draw.pieslice([1482,69,1499,83],180, 270, fill=self.czarny_gsmr)
			# draw.pieslice([1555,69,1571,83],270, 0, fill=self.czarny_gsmr)
			
			#ikonka glosnosci
			draw.line((1675,195, 1675, 224), fill=self.czarny_gsmr, width=2)
			draw.line((1670,215, 1675, 224), fill=self.czarny_gsmr, width=2)
			draw.line((1670,215, 1666, 215), fill=self.czarny_gsmr, width=2)
			draw.line((1666,204, 1666, 215), fill=self.czarny_gsmr, width=2)
			draw.line((1666,204, 1670, 204), fill=self.czarny_gsmr, width=2)
			draw.line((1675,195, 1670, 204), fill=self.czarny_gsmr, width=2)
			
			#linie
			draw.line((1330,25, 1330, 299), fill=self.czarny_gsmr, width=1)
			draw.line((1628,25, 1628, 299), fill=self.czarny_gsmr, width=1)
			draw.line((1330,57, 1750, 57), fill=self.czarny_gsmr, width=1)
			draw.line((1342,228, 1750, 228), fill=self.czarny_gsmr, width=1)		
			draw.line((1291,91, 1330, 91), fill=self.czarny_gsmr, width=1)	
			draw.line((1291,159, 1330, 159), fill=self.czarny_gsmr, width=1)	
			draw.line((1291,227, 1330, 227), fill=self.czarny_gsmr, width=1)	
			draw.line((1628,89, 1750, 89), fill=self.czarny_gsmr, width=1)	
			draw.line((1628,123, 1750, 123), fill=self.czarny_gsmr, width=1)	
			draw.line((1628,158, 1750, 158), fill=self.czarny_gsmr, width=1)	
			draw.line((1342,298, 1342, 228), fill=self.czarny_gsmr, width=1)	
			draw.line((1382,298, 1382, 228), fill=self.czarny_gsmr, width=1)			
			draw.line((1422,298, 1422, 228), fill=self.czarny_gsmr, width=1)			
			draw.line((1462,298, 1462, 228), fill=self.czarny_gsmr, width=1)			
			draw.line((1504,298, 1504, 228), fill=self.czarny_gsmr, width=1)			
			draw.line((1546,298, 1546, 228), fill=self.czarny_gsmr, width=1)	
			draw.line((1586,298, 1586, 228), fill=self.czarny_gsmr, width=1)							
			draw.line((1668,298, 1668, 228), fill=self.czarny_gsmr, width=1)			
			draw.line((1710,298, 1710, 228), fill=self.czarny_gsmr, width=1)	
			draw.line((1432,57, 1432, 25), fill=self.czarny_gsmr, width=1)		
			
			#napisy
			if state['radio_channel'] < 10:
					draw.text((1340,56), "K " + zmienna_kanalu, font=self.gsmr4, fill=self.czarny_gsmr)
			if (state['radio_channel']==10):
					draw.text((1340,56), "K" + zmienna_kanalu, font=self.gsmr4, fill=self.czarny_gsmr)		
					
			# draw.text((1340,138), u'Gruppenruf 3', fill=self.czarny_gsmr, font=self.gsmr1)	
			# draw.text((1340,163), u'Zew 3', fill=self.czarny_gsmr, font=self.gsmr1)		
			# draw.text((1489,128), u'ZEW 3', fill=self.szary_gsmr, font=self.maly_arial)	
			draw.text((1344,32), godz +":"+ min +":"+ sec, fill=self.czarny_gsmr, font=self.gsmr1)
			draw.text((1456,32), u'analog     (PKP)', fill=self.czarny_gsmr, font=self.gsmr1)
			draw.text((1291,257), u'KASUJ', fill=self.czarny_gsmr, font=self.gsmr2)
			draw.text((1346,240), u'ZEW', fill=self.czarny_gsmr, font=self.gsmr3)
			draw.text((1356,270), u'1', fill=self.czarny_gsmr, font=self.gsmr1)
			draw.text((1386,240), u'ZEW', fill=self.czarny_gsmr, font=self.gsmr3)
			draw.text((1396,270), u'2', fill=self.czarny_gsmr, font=self.gsmr1)
			draw.text((1426,240), u'ZEW', fill=self.czarny_gsmr, font=self.gsmr3)
			draw.text((1436,270), u'3', fill=self.czarny_gsmr, font=self.gsmr1)
			draw.text((1466,255), u'RStp', fill=self.czarny_gsmr, font=self.gsmr3)
			draw.text((1512,255), u'SQL', fill=self.czarny_gsmr, font=self.gsmr3)
			draw.text((1547,255), u'MON', fill=self.czarny_gsmr, font=self.gsmr3)
			draw.text((1587,255), u'Kanal', fill=self.czarny_gsmr, font=self.gsmr3)
			draw.text((1632,251), u'SYS', fill=self.czarny_gsmr, font=self.gsmr1)
			draw.text((1670,255), u'CZAS', fill=self.czarny_gsmr, font=self.gsmr3)		
			
		return obrazek